// This code was autogenerated from socket.service.proto, do not edit.

package io.silentium.go;

import java.util.UUID;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import infrastructure.Utils.Constants;
import infrastructure.domain.UserInfo;
import io.micronaut.http.HttpRequest;
import io.micronaut.http.HttpResponse;
import io.micronaut.http.HttpHeaders;
import silentium.micronaut.nats.annotations.NATSClient;
import io.micronaut.security.annotation.Secured;
import infrastructure.Utils.Constants;
import io.micronaut.security.rules.SecurityRule;
import io.micronaut.http.annotation.Post;
import io.reactivex.Single;
import io.reactivex.Completable;
import java.util.List;
import java.util.Map;
import io.micronaut.http.annotation.Body;
import io.swagger.v3.oas.annotations.media.Schema;

public class   SocketServiceApi {

// Type definitions
	@Builder(toBuilder = true)
	@Data
	@AllArgsConstructor
	@NoArgsConstructor
    @Schema(name="SendToDeviceRequest", description="SendToDeviceRequest Description")
    public static class SendToDeviceRequest {
			private String deviceId;
			private SendRequestMessage messageInfo;
    }
	@Builder(toBuilder = true)
	@Data
	@AllArgsConstructor
	@NoArgsConstructor
    @Schema(name="SendToUserRequest", description="SendToUserRequest Description")
    public static class SendToUserRequest {
			private UUID userId;
			private SendRequestMessage messageInfo;
    }
	@Builder(toBuilder = true)
	@Data
	@AllArgsConstructor
	@NoArgsConstructor
    @Schema(name="SendRequestMessage", description="SendRequestMessage Description")
    public static class SendRequestMessage {
			private String id;
			private Topic topic;
			private String messageBody;
			private Map<String, String> headers;
			private long statusCode;
			private String subject;
			private Topic responseTopic;
    }
	@Builder(toBuilder = true)
	@Data
	@AllArgsConstructor
	@NoArgsConstructor
    @Schema(name="SendToPatientRequest", description="SendToPatientRequest Description")
    public static class SendToPatientRequest {
			private String externalUserId;
			private SendRequestMessage messageInfo;
    }
	@Builder(toBuilder = true)
	@Data
	@AllArgsConstructor
	@NoArgsConstructor
    @Schema(name="MessageResponse", description="MessageResponse Description")
    public static class MessageResponse {
			private String id;
			private Topic topic;
			private String messageBody;
			private Map<String, String> headers;
			private Long statusCode;
    }
	@Builder(toBuilder = true)
	@Data
	@AllArgsConstructor
	@NoArgsConstructor
    @Schema(name="OpenCompanionMessage", description="OpenCompanionMessage Description")
    public static class OpenCompanionMessage {
			private String sessionId;
			private String deviceId;
    }
	@Builder(toBuilder = true)
	@Data
	@AllArgsConstructor
	@NoArgsConstructor
    @Schema(name="SendToUsersRequest", description="SendToUsersRequest Description")
    public static class SendToUsersRequest {
			private List<UUID> userIds;
			private SendRequestMessage messageInfo;
    }
	@Builder(toBuilder = true)
	@Data
	@AllArgsConstructor
	@NoArgsConstructor
    @Schema(name="SendToUsersResponse", description="SendToUsersResponse Description")
    public static class SendToUsersResponse {
			private List<UUID> userIds;
			private SendRequestMessage messageInfo;
    }
	@Builder(toBuilder = true)
	@Data
	@AllArgsConstructor
	@NoArgsConstructor
    @Schema(name="SendToCareProviderPatientsRequest", description="SendToCareProviderPatientsRequest Description")
    public static class SendToCareProviderPatientsRequest {
			private UUID careProviderId;
			private SendRequestMessage messageInfo;
    }
	@Builder(toBuilder = true)
	@Data
	@AllArgsConstructor
	@NoArgsConstructor
    @Schema(name="SendToCareProviderMembersRequest", description="SendToCareProviderMembersRequest Description")
    public static class SendToCareProviderMembersRequest {
			private UUID careProviderId;
			private SendRequestMessage messageInfo;
    }
	@Builder(toBuilder = true)
	@Data
	@AllArgsConstructor
	@NoArgsConstructor
    @Schema(name="DeviceEvent", description="DeviceEvent Description")
    public static class DeviceEvent {
			private String type;
			private String ticketId;
			private long deviceNumber;
			private UUID patientId;
			private UUID careProviderId;
			private UUID deviceId;
			private UUID conversationId;
    }
	@Builder(toBuilder = true)
	@Data
	@AllArgsConstructor
	@NoArgsConstructor
    @Schema(name="SendEventToDeviceRequest", description="SendEventToDeviceRequest Description")
    public static class SendEventToDeviceRequest {
			private String deviceId;
			private DeviceEvent deviceEvent;
    }
	@Builder(toBuilder = true)
	@Data
	@AllArgsConstructor
	@NoArgsConstructor
    @Schema(name="SendToDeviceWithResponseRequest", description="SendToDeviceWithResponseRequest Description")
    public static class SendToDeviceWithResponseRequest {
			private UUID deviceId;
			private String url;
			private String body;
    }
	@Builder(toBuilder = true)
	@Data
	@AllArgsConstructor
	@NoArgsConstructor
    @Schema(name="NatRequest", description="NatRequest Description")
    public static class NatRequest {
			private Map<String, String> headers;
			private String subject;
			private String method;
			private String url;
			private String body;
    }
	@Builder(toBuilder = true)
	@Data
	@AllArgsConstructor
	@NoArgsConstructor
    @Schema(name="NatResponse", description="NatResponse Description")
    public static class NatResponse {
			private Map<String, String> headers;
			private String status;
			private int statusCode;
			private String body;
    }
	@Builder(toBuilder = true)
	@Data
	@AllArgsConstructor
	@NoArgsConstructor
    @Schema(name="SendToDeviceResponse", description="SendToDeviceResponse Description")
    public static class SendToDeviceResponse {
			private UUID deviceId;
			private String jsonData;
    }
	@Builder(toBuilder = true)
	@Data
	@AllArgsConstructor
	@NoArgsConstructor
    @Schema(name="NotifySocketConnCreatedRequest", description="NotifySocketConnCreatedRequest Description")
    public static class NotifySocketConnCreatedRequest {
			private String userId;
			private String sessionId;
    }
	@Builder(toBuilder = true)
	@Data
	@AllArgsConstructor
	@NoArgsConstructor
    @Schema(name="SendToClientRequest", description="SendToClientRequest Description")
    public static class SendToClientRequest {
			private String sessionId;
			private SendRequestMessage messageInfo;
    }

// enum definitions
	@Schema(name="Topic", description="Topic Description")
	public static enum Topic {
        	PING,
        	PONG,
        	CHAT,
        	APPOINTMENT,
        	COMMUNICATION_PLAN,
        	EMPLOYEE_CHANGED,
        	APPOINTMENT_CHANGED,
        	CUSTOMER_CHANGED,
	}
	@Schema(name="DeviceRequestType", description="DeviceRequestType Description")
	public static enum DeviceRequestType {
        	DEVICE_EXISTED,
        	DEVICE_READY,
        	DEVICE_ADDED,
        	DEVICE_LOGIN,
        	ADMIN_PAIRED_SUCCESS,
	}
	@Schema(name="UrlCompanionAction", description="UrlCompanionAction Description")
	public static enum UrlCompanionAction {
        	OpenWS,
	}

// service definition
    public interface SocketService {
		
		@Post("/sendEventToDevice")
		Single<MessageResponse>sendEventToDevice(@Body SendEventToDeviceRequest request);
		
		@Post("/sendToDevice")
		Single<MessageResponse>sendToDevice(@Body SendToDeviceRequest request);
		
		@Post("/sendToUser")
		Single<MessageResponse>sendToUser(@Body SendToUserRequest request);
		
		@Post("/sendToUsers")
		Single<SendToUsersResponse>sendToUsers(@Body SendToUsersRequest request);
		
		@Post("/sendToPatient")
		Single<MessageResponse>sendToPatient(@Body SendToPatientRequest request);
		
		@Post("/sendToCareProviderPatients")
		Single<MessageResponse>sendToCareProviderPatients(@Body SendToCareProviderPatientsRequest request);
		
		@Post("/sendToCareProviderMembers")
		Single<MessageResponse>sendToCareProviderMembers(@Body SendToCareProviderMembersRequest request);
		
		@Post("/sendToDeviceWithResponse")
		Single<SendToDeviceResponse>sendToDeviceWithResponse(@Body SendToDeviceWithResponseRequest request);
		
		@Post("/notifySocketConnCreated")
		Completable notifySocketConnCreated(@Body NotifySocketConnCreatedRequest request);
		
		@Post("/sendToClient")
		Single<MessageResponse>sendToClient(@Body SendToClientRequest request);
    }
	@NATSClient(id = "api.service.socket", path = "/api/service/socket")
	public interface  SocketServiceClient extends SocketService  {}
}

